#include <algorithm>
#include <cstdlib>
#include <cassert>
#include <fstream>
#include <string>
#include <vector>
#include <deque>

using std::ifstream; using std::ofstream; using std::string; using std::vector; using std::deque; using std::swap;

static const char ALPH[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-. ";

#define ALPH_SIZE (sizeof(ALPH) - 1)

static deque<string> QUEUE; static deque<string> FNAME; static vector<int> ipos; static vector<vector<int> > next;
static string BUFF; static long numf, num1, num2, lenf, numt, tid, rnd;

void gener(int l) {
	if (l == lenf) { FNAME.push_back(BUFF); return; }
	for (int k = ipos[l], i = 0; (i < lenf) && (FNAME.size() < numf); ++ i) { BUFF[k] = next[k][i]; gener(l + 1); }
}

int main(int argc, char *argv[]) {

	num1 = atol(argv[1]); num2 = atol(argv[2]); numf = num1 + num2; lenf = atol(argv[3]); numt = atol(argv[4]);
	tid = atol(argv[5]); rnd = atol(argv[6]);
	srand(rnd);

	//Генерируем набор случайных имен файлов:
	FNAME.resize(0); BUFF.resize(lenf); ipos.resize(lenf); next.resize(lenf);
	for (int l = 0; l < lenf; ++ l) {
		next[l].resize(ALPH_SIZE);
		for (int i = 0; i < ALPH_SIZE; ++ i) next[l][i] = ALPH[i];
		for (int i = 0; i < ALPH_SIZE; ++ i) {
			swap(next[l][rand() % ALPH_SIZE], next[l][i]);
		}
		ipos[l] = l;
	}
	for (int l = 0; l < lenf; ++ l) {
		swap(ipos[rand() % lenf], ipos[rand() % lenf]);
	}
	gener(0);

	//Выводим исходное состояние каталога:
	ofstream fid("input.txt"); fid << num1 << "\n";
	for (int i = 0; i < numf; ++ i) {
		swap(FNAME[rand() % numf], FNAME[rand() % numf]);
	}
	for (int i = 0; i < num1; ++ i) {
		fid << "\"" << FNAME[i] << "\"\n";
	}

	//Формируем очередь из новых файлов:
	for (int i = num1; i < numf; ++ i) {
		QUEUE.push_front(FNAME.back());
		FNAME.pop_back();
	}

	//Генерируем случайные транзакции:
	fid << "\n" << numt << "\n";
	for (int i = 0; i < numt; ++ i) {
		string str1, str2; int act = (tid >= 4)? (rand() % 4): (tid); bool flag = true;
		do {
			switch (act) {
			case 3:
				if (!QUEUE.size()) { act = 0; break; } //Запустить операцию удаления для конечной цели;
				if (!FNAME.size()) { act = 1; break; } //Запустить операцию на добавление источника;
				str2 = QUEUE.front(); QUEUE.pop_front(); str1 = FNAME.back(); FNAME.push_back(str2);
				swap(FNAME[rand() % FNAME.size()], FNAME.back());
				fid << "cpy \"" << str1 << "\" \"" << str2 << "\"\n";
				flag = false;
				break;
			case 2:
				if (!QUEUE.size()) { act = 0; break; } //Запустить операцию удаления для конечной цели;
				if (!FNAME.size()) { act = 1; break; } //Запустить операцию на добавление источника;
				str2 = QUEUE.front(); QUEUE.pop_front();
				str1 = FNAME.back(); FNAME.pop_back();
				if (!rnd || (rand() % 100 < 10)) {
					FNAME.push_front(str2);
					QUEUE.push_front(str1);
				}
				else {
					FNAME.push_back(str2); swap(FNAME[rand() % FNAME.size()], FNAME.back());
					QUEUE.push_back(str1);
				}
				fid << "mov \"" << str1 << "\" \"" << str2 << "\"\n";
				flag = false;
				break;
			case 1:
				if (!QUEUE.size()) { act = 0; break; } //Запустить операцию удаления для конечной цели;
				str2 = QUEUE.front(); QUEUE.pop_front();
				FNAME.push_back(str2); swap(FNAME[rand() % FNAME.size()], FNAME.back());
				fid << "new \"" << str2 << "\"\n";
				flag = false;
				break;
			case 0:
				if (!FNAME.size()) { act = 1; break; } //Запустить операцию на добавление источника;
				str1 = FNAME.back(); FNAME.pop_back();
				QUEUE.push_back(str1);
				fid << "del \"" << str1 << "\"\n";
				flag = false;
				break;
			}
		} while (flag);
	}
	fid.close();

	return 0;
}
